function [input_image, input_image_y, input_image_cr, input_image_cb, input_image_rm, input_image_gm, input_image_bm] = Xil_YCrCb2RGB_init_mdl()

%input_image = imread('paradise.ppm','ppm');
%input_image = imread('pattern1.tif','tiff');
%input_image = imread('pattern0.tif','tiff');

IN_MAX = 255.49;
input_image =  IN_MAX*reshape( jet(256) , 16,16,3);
[ysize,xsize,planes] = size(input_image);

figure(1); colormap('gray');

subplot(2,2,1);
imshow( uint8(round(input_image))); xlabel('ORIGINAL RGB');

% Use rgb2ycbcr double precision conversion
% AC=612/2048;        % 0.299   => Biometric constants
% BC=233/2048;        % 0.114    
% CC=0.5/(1-AC);      % Scaling constants reducing the dynamic range 
% DC=0.5/(1-BC);      % of Cb and Cr to -0.5 to 0.5 (0 to 1 with offset compensation

  color_sub = [gcs, '/ColorSpace Conversion YCrCb to RGB'];
  param_a = str2num(get_param(color_sub, 'coefA'));
  param_b = str2num(get_param(color_sub, 'coefB'));
  param_d = str2num(get_param(color_sub, 'coefC'));
  param_c = str2num(get_param(color_sub, 'coefD'));
  c_bits  = str2num(get_param(color_sub, 'c_bits'));

  % core parameterization values:
  % AC = round( pow2(c_bits-2)* 1/param_c);
  % BC = round( pow2(c_bits-2)* (-param_a)/param_c*1/(1-param_a-param_b));
  % CC = round( pow2(c_bits-2)* (-param_b)/param_d*1/(1-param_a-param_b));
  % DC = round( pow2(c_bits-2)* 1/param_d);

[matlab_y, matlab_cr, matlab_cb] = double_rgb2ycrcb(input_image(:,:,1), input_image(:,:,2), input_image(:,:,3), param_a, param_b, param_c, param_d);
uint8_y  = uint8(round(matlab_y*IN_MAX));
uint8_cr = uint8(round(matlab_cr*IN_MAX));
uint8_cb = uint8(round(matlab_cb*IN_MAX));
[ input_image_rm, input_image_gm, input_image_bm ] = double_ycrcb2rgb(uint8_y, uint8_cr, uint8_cb, param_a, param_b, param_c, param_d);

uint8_r = uint8(round( input_image_rm*IN_MAX));
uint8_g = uint8(round( input_image_gm*IN_MAX));
uint8_b = uint8(round( input_image_bm*IN_MAX));

subplot(2,2,2);
imshow(uint8_r); xlabel('MATLAB double R');
subplot(2,2,3);
imshow(uint8_g); xlabel('MATLAB double G');
subplot(2,2,4);
imshow(uint8_b); xlabel('MATLAB double B');

figure(2); colormap('gray');
subplot(2,2,2); 
imshow(matlab_y); xlabel('Generated Y');
subplot(2,2,3); 
imshow(matlab_cb); xlabel('Generated Cb');
subplot(2,2,4); 
imshow(matlab_cr); xlabel('Generated Cr');

input_image_y  =  reshape( uint8_y, 1, xsize*ysize);
input_image_cr =  reshape( uint8_cr, 1, xsize*ysize);
input_image_cb =  reshape( uint8_cb, 1, xsize*ysize);

end
